// List of available block formats (not in use)
var BlockFormats = [
   "Textabsatz","berschrift 1","berschrift 2","berschrift 3","berschrift 4",
   "berschrift 5","berschrift 6","Vorformatiert","Adresse","Laufschrift",
   "Quelltext", "Textblock"
];

var BlockTags = {
  "Textabsatz" : 'p',
  "berschrift 1" : 'h1',
  "berschrift 2" : 'h2',
  "berschrift 3" : 'h3',
  "berschrift 4" : 'h4',
  "berschrift 5" : 'h5',
  "berschrift 6" : 'h6',
  "Vorformatiert" : 'pre',
  "Adresse" : 'address',
  "Laufschrift" : 'marquee',
  "Quelltext" : 'code',
  "Textblock" : 'blockquote'
};
	
// List of available actions and their respective ID and images
var ToolbarList = {
//Name              buttonID                 buttonTitle           buttonImage                            buttonImageRollover
  "bold":           ['Bold',                 'fett',               imagesDir + 'bold.gif',               imagesDir + 'bold_on.gif'],
  "italic":         ['Italic',               'kursiv',             imagesDir + 'italics.gif',            imagesDir + 'italics_on.gif'],
  "underline":      ['Underline',            'unterstrichen',          imagesDir + 'underline.gif',          imagesDir + 'underline_on.gif'],
	"strikethrough":  ['Strikethrough',        'durchgestrichen',      imagesDir + 'strikethrough.gif',      imagesDir + 'strikethrough_on.gif'],
	"seperator":      ['',                     '',                   imagesDir + 'seperator.gif',          imagesDir + 'seperator.gif'],
	"subscript":      ['Subscript',            'Subscript',          imagesDir + 'subscript.gif',          imagesDir + 'subscript_on.gif'],
	"superscript":    ['Superscript',          'Superscript',        imagesDir + 'superscript.gif',        imagesDir + 'superscript_on.gif'],
	"justifyleft":    ['Justifyleft',          'linksb&uuml;ndig',        imagesDir + 'justify_left.gif',       imagesDir + 'justify_left_on.gif'],
	"justifycenter":  ['Justifycenter',        'zentriert',      imagesDir + 'justify_center.gif',     imagesDir + 'justify_center_on.gif'],
	"justifyright":   ['Justifyright',         'rechtsb&uuml;ndig',       imagesDir + 'justify_right.gif',      imagesDir + 'justify_right_on.gif'],
	"justifyfull":    ['Justifyfull',          'Blocksatz',       imagesDir + 'justify_full.gif',      imagesDir + 'justify_full_on.gif'],
	"unorderedlist":  ['InsertUnorderedList',  'Liste (unsortiert)',imagesDir + 'list_unordered.gif',     imagesDir + 'list_unordered_on.gif'],
	"orderedlist":    ['InsertOrderedList',    'Liste (sortiert)',  imagesDir + 'list_ordered.gif',       imagesDir + 'list_ordered_on.gif'],
	"outdent":        ['Outdent',              'Einzug verkleinern',            imagesDir + 'indent_left.gif',        imagesDir + 'indent_left_on.gif'],
	"indent":         ['Indent',               'Einzug vergr&ouml;&szlig;ern',             imagesDir + 'indent_right.gif',       imagesDir + 'indent_right_on.gif'],
	"cut":            ['Cut',                  'Ausschneiden',                imagesDir + 'cut.gif',                imagesDir + 'cut_on.gif'],
	"copy":           ['Copy',                 'Kopieren',               imagesDir + 'copy.gif',               imagesDir + 'copy_on.gif'],
  "paste":          ['Paste',                'Einf&uuml;gen',              imagesDir + 'paste.gif',              imagesDir + 'paste_on.gif'],
	"forecolor":      ['ForeColor',            'Textfarbe',          imagesDir + 'forecolor.gif',          imagesDir + 'forecolor_on.gif'],
	"backcolor":      ['BackColor',            'Hintergrundfarbe',          imagesDir + 'backcolor.gif',          imagesDir + 'backcolor_on.gif'],
	"undo":           ['Undo',                 'R&uuml;ckg&auml;ngig',               imagesDir + 'undo.gif',               imagesDir + 'undo_on.gif'],
	"redo":           ['Redo',                 'Wiederherstellen',               imagesDir + 'redo.gif',               imagesDir + 'redo_on.gif'],
	"inserttable":    ['InsertTable',          'Tabelle einf&uuml;gen',        imagesDir + 'insert_table.gif',       imagesDir + 'insert_table_on.gif'],
	"insertimage":    ['InsertImage',          'Bild einf&uuml;gen',        imagesDir + 'insert_picture.gif',     imagesDir + 'insert_picture_on.gif'],
	"createlink":     ['CreateLink',           'Link einf&uuml;gen',         imagesDir + 'insert_hyperlink.gif',   imagesDir + 'insert_hyperlink_on.gif'],
	"viewSource":     ['ViewSource',           'Quelltext bearbeiten',         imagesDir + 'view_source.gif',        imagesDir + 'view_source_on.gif'],
	"viewText":       ['ViewText',             'Edito anzeigen',           imagesDir + 'view_text.gif',          imagesDir + 'view_text_on.gif'],
	"help":           ['Help',                 '&Uuml;ber ...',               imagesDir + 'help.gif',               imagesDir + 'help_on.gif'],
	"selectfont":     ['SelectFont',           'Schriftart ausw&auml;hlen',         imagesDir + 'select_font.gif',        imagesDir + 'select_font_on.gif'],
	"selectsize":     ['SelectSize',           'Schriftgr&ouml;&szlig;e ausw&auml;hlen',         imagesDir + 'select_size.gif',        imagesDir + 'select_size_on.gif'],
	// eb: inserted
	"selectstyle":     ['SelectStyle',           'Absatzformat ausw&auml;hlen',         imagesDir + 'select_format.gif',        imagesDir + 'select_format_on.gif'],
	"hruler":     ['hruler',           'Horizontale Linie',         imagesDir + 'hr.gif',        imagesDir + 'hr_on.gif'],
	"insertlayer":     ['insertlayer',           'Ebene einf&uuml;gen',         imagesDir + 'inslayer.gif',        imagesDir + 'inslayer_on.gif']
};
