// List of available block formats (not in use)
var BlockFormats = [
   "Paragraph","Heading 1","Heading 2","Heading 3","Heading 4",
   "Heading 5","Heading 6","Preformatted","Address","Marquee", "Code", 
   "Blockquote"
];

var BlockTags = {
  "Paragraph" : 'p',
  "Heading 1" : 'h1',
  "Heading 2" : 'h2',
  "Heading 3" : 'h3',
  "Heading 4" : 'h4',
  "Heading 5" : 'h5',
  "Heading 6" : 'h6',
  "Preformatted" : 'pre',
  "Address" : 'address',
  "Marquee" : 'marquee',
  "Code" : 'code',
  "Blockquote" : 'blockquote'
};
	
// List of available actions and their respective ID and images
var ToolbarList = {
//Name              buttonID                 buttonTitle           buttonImage                            buttonImageRollover
  "bold":           ['Bold',                 'Bold',               imagesDir + 'bold.gif',               imagesDir + 'bold_on.gif'],
  "italic":         ['Italic',               'Italic',             imagesDir + 'italics.gif',            imagesDir + 'italics_on.gif'],
  "underline":      ['Underline',            'Underline',          imagesDir + 'underline.gif',          imagesDir + 'underline_on.gif'],
	"strikethrough":  ['Strikethrough',        'Strikethrough',      imagesDir + 'strikethrough.gif',      imagesDir + 'strikethrough_on.gif'],
	"seperator":      ['',                     '',                   imagesDir + 'seperator.gif',          imagesDir + 'seperator.gif'],
	"subscript":      ['Subscript',            'Subscript',          imagesDir + 'subscript.gif',          imagesDir + 'subscript_on.gif'],
	"superscript":    ['Superscript',          'Superscript',        imagesDir + 'superscript.gif',        imagesDir + 'superscript_on.gif'],
	"justifyleft":    ['Justifyleft',          'Align left',        imagesDir + 'justify_left.gif',       imagesDir + 'justify_left_on.gif'],
	"justifycenter":  ['Justifycenter',        'Align centered',      imagesDir + 'justify_center.gif',     imagesDir + 'justify_center_on.gif'],
	"justifyright":   ['Justifyright',         'Align right',       imagesDir + 'justify_right.gif',      imagesDir + 'justify_right_on.gif'],
	"justifyfull":    ['Justifyfull',          'Yustify',       imagesDir + 'justify_full.gif',      imagesDir + 'justify_full_on.gif'],
	"unorderedlist":  ['InsertUnorderedList',  'Unordered list',imagesDir + 'list_unordered.gif',     imagesDir + 'list_unordered_on.gif'],
	"orderedlist":    ['InsertOrderedList',    'Ordered list',  imagesDir + 'list_ordered.gif',       imagesDir + 'list_ordered_on.gif'],
	"outdent":        ['Outdent',              'Outdent',            imagesDir + 'indent_left.gif',        imagesDir + 'indent_left_on.gif'],
	"indent":         ['Indent',               'Indent',             imagesDir + 'indent_right.gif',       imagesDir + 'indent_right_on.gif'],
	"cut":            ['Cut',                  'Cut',                imagesDir + 'cut.gif',                imagesDir + 'cut_on.gif'],
	"copy":           ['Copy',                 'Copy',               imagesDir + 'copy.gif',               imagesDir + 'copy_on.gif'],
  "paste":          ['Paste',                'Paste',              imagesDir + 'paste.gif',              imagesDir + 'paste_on.gif'],
	"forecolor":      ['ForeColor',            'Text color',          imagesDir + 'forecolor.gif',          imagesDir + 'forecolor_on.gif'],
	"backcolor":      ['BackColor',            'Background color',          imagesDir + 'backcolor.gif',          imagesDir + 'backcolor_on.gif'],
	"undo":           ['Undo',                 'Undo',               imagesDir + 'undo.gif',               imagesDir + 'undo_on.gif'],
	"redo":           ['Redo',                 'Redo',               imagesDir + 'redo.gif',               imagesDir + 'redo_on.gif'],
	"inserttable":    ['InsertTable',          'Insert Table',        imagesDir + 'insert_table.gif',       imagesDir + 'insert_table_on.gif'],
	"insertimage":    ['InsertImage',          'Insert Image',        imagesDir + 'insert_picture.gif',     imagesDir + 'insert_picture_on.gif'],
	"createlink":     ['CreateLink',           'Insert link',         imagesDir + 'insert_hyperlink.gif',   imagesDir + 'insert_hyperlink_on.gif'],
	"viewSource":     ['ViewSource',           'Edit source',         imagesDir + 'view_source.gif',        imagesDir + 'view_source_on.gif'],
	"viewText":       ['ViewText',             'Show Editor',           imagesDir + 'view_text.gif',          imagesDir + 'view_text_on.gif'],
	"help":           ['Help',                 'About ...',               imagesDir + 'help.gif',               imagesDir + 'help_on.gif'],
	"selectfont":     ['SelectFont',           'Select font',         imagesDir + 'en/select_font.gif',        imagesDir + 'en/select_font_on.gif'],
	"selectsize":     ['SelectSize',           'Select Size',         imagesDir + 'en/select_size.gif',        imagesDir + 'en/select_size_on.gif'],
	// eb: inserted
	"selectstyle":     ['SelectStyle',           'Block style',         imagesDir + 'en/select_format.gif',        imagesDir + 'en/select_format_on.gif'],
	"hruler":     ['hruler',           'Horizontal ruler',         imagesDir + 'hr.gif',        imagesDir + 'hr_on.gif'],
	"insertlayer":     ['insertlayer',           'Insert Layer',         imagesDir + 'inslayer.gif',        imagesDir + 'inslayer_on.gif']
};
