//
// openWYSIWYG v1.01 Copyright (c) 2006 openWebWare.com
// KsWyEdit v1.00 Copyright (c) 2006 kiezsoft.de
// This copyright notice MUST stay intact for use.
//
// An open source WYSIWYG editor for use in web based applications.
// For full source code and docs, visit http://www.openwebware.com/
// and http://www.kiezsoft.de
// This library is free software; you can redistribute it and/or modify 
// it under the terms of the GNU Lesser General Public License as published 
// by the Free Software Foundation; either version 2.1 of the License, or 
// (at your option) any later version.
//
// This library is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public 
// License for more details.
//
// You should have received a copy of the GNU Lesser General Public License along 
// with this library; if not, write to the Free Software Foundation, Inc., 59 
// Temple Place, Suite 330, Boston, MA 02111-1307 USA 

/* ---------------------------------------------------------------------- *\
  Global Variables: Set global variables such as images directory, 
	                  WYSIWYG Height, Width, and CSS Directory.
\* ---------------------------------------------------------------------- */
// eb: new (external) variable wysiwygDir contains directory path of script relative to caller
// Images Directory
imagesDir = wysiwygDir + "/icons/";
// CSS Directory
cssDir = wysiwygDir + "/styles/";

// Popups Directory
popupsDir = wysiwygDir + "/popups/";
//language dependent subdir
popupExt = "";

// Include Style Sheet
document.write('<link rel="stylesheet" type="text/css" href="' +cssDir+ 'styles.css">\n');


function include(file)
{
/*  var script  = document.createElement('script');
  script.src  = file;
  script.type = 'text/javascript';
  document.getElementsByTagName('head').item(0).appendChild(script);
  */
document.write('<script type="text/javascript" src="'
    + file + '"></script>');  
}

function getBrowserLanguage()
{
   var lang = navigator.browserLanguage;
   if (!lang) lang = navigator.language;
   return lang;
}
/* ---------------------------------------------------------------------- *\
  Toolbar Settings: Set the features and buttons available in the WYSIWYG
	                  Toolbar.
\* ---------------------------------------------------------------------- */
include(wysiwygDir+"/ressources.js");
if (getBrowserLanguage() == "de")
  include(wysiwygDir+"/ressources_de.js");
else
{
  include(wysiwygDir+"/ressources_en.js");
  popupExt="en/";
}


function getParentByNodeName(tagname,node)
{
   if (!node) return null;
   var parent = node.parentNode;
   if (!parent) return null;
   if (tagname.toLowerCase() == parent.nodeName.toLowerCase())
      return parent;
   return getParentByNodeName(tagname,parent);
}

/* ---------------------------------------------------------------------- *\
  Function    : insertAdjacentHTML(), insertAdjacentText() and insertAdjacentElement()
  Description : Emulates insertAdjacentHTML(), insertAdjacentText() and 
	              insertAdjacentElement() three functions so they work with 
								Netscape 6/Mozilla
  Notes       : by Thor Larholm me@jscript.dk
\* ---------------------------------------------------------------------- */
if(typeof HTMLElement!="undefined" && !HTMLElement.prototype.insertAdjacentElement){
  HTMLElement.prototype.insertAdjacentElement = function
  (where,parsedNode)
	{
	  switch (where){
		case 'beforeBegin':
			this.parentNode.insertBefore(parsedNode,this)
			break;
		case 'afterBegin':
			this.insertBefore(parsedNode,this.firstChild);
			break;
		case 'beforeEnd':
			this.appendChild(parsedNode);
			break;
		case 'afterEnd':
			if (this.nextSibling) 
      this.parentNode.insertBefore(parsedNode,this.nextSibling);
			else this.parentNode.appendChild(parsedNode);
			break;
		}
	}

	HTMLElement.prototype.insertAdjacentHTML = function
  (where,htmlStr)
	{
		var r = this.ownerDocument.createRange();
		r.setStartBefore(this);
		var parsedHTML = r.createContextualFragment(htmlStr);
		this.insertAdjacentElement(where,parsedHTML)
	}


	HTMLElement.prototype.insertAdjacentText = function
  (where,txtStr)
	{
		var parsedText = document.createTextNode(txtStr)
		this.insertAdjacentElement(where,parsedText)
	}
};

// Map of created editors - key is the ID of accociated textarea, value is
// reference to editor object.
editorMap = new Array();
// =====================================================================
// WYSIWYG Editor class
// ctor Parameters:
// editWidth, editHeight : width and height of editor, specified in pixels or percent
function KsWyEdit(editWidth,editHeight)
{
   this.width = editWidth;
   this.height = editHeight;
// Create viewTextMode global variable and set to 0
// enabling all toolbar commands while in HTML mode
    this.viewTextMode = 0;
    // id of related TextArea
    this.id = null;
    // related TextArea
    this.textArea = null;
    // iFrame element of editor
    this.editFrame = null;
  
// eb: inserted
/*
Function is called from onReset handlers and resets editor text.
arg: ID of textarea
*/ 
     this.reset = function()
     {
       if (this.viewTextMode == 1)
          this.viewText();
       var txt = this.textArea.value;
       if (txt == "") txt = "&nbsp;"; // eb: Hack for Mozilla
	    var doc = this.editFrame.contentWindow.document;
	    doc.body.innerHTML = txt;
     }

      /* ---------------------------------------------------------------------- *\
        Function    : updateTextArea()
        Description : Updates the text area value with the HTML source of the WYSIWYG
      \* ---------------------------------------------------------------------- */
      this.updateTextArea = function() 
      {
         if (this.viewTextMode != 0)
         {
            alert("Datenbernahme im HTML-Modus nicht mglich");
            return false;
         }
         this.textArea.value = this.editFrame.contentWindow.document.body.innerHTML;
         return true;
      };

   /* ---------------------------------------------------------------------- *\
     Function    : outputStyleSelect() // eb: inserted
     Description : creates the Style Select drop down and inserts it into 
   	              the toolbar
     Usage       : outputStyleSelect()
   \* ---------------------------------------------------------------------- */
   this.outputStyleSelect = function()
   {
     var StyleSelectObj        = ToolbarList['selectstyle'];
     var StyleSelect           = StyleSelectObj[2];
     var StyleSelectOn         = StyleSelectObj[3];
     var StyleSelectDropDown = new Array;
   	StyleSelectDropDown[this.id] = '<table border="0" cellpadding="0" cellspacing="0"><tr><td onMouseOver="document.getElementById(\'selectStyle' + this.id + '\').src=\'' + StyleSelectOn + '\';" onMouseOut="document.getElementById(\'selectStyle' + this.id + '\').src=\'' + StyleSelect + '\';"><img src="' + StyleSelect + '" id="selectStyle' + this.id + '" width="85" height="20" onClick="editorMap[\''+this.id+'\'].showStyles();" unselectable="on"><br>';
   	StyleSelectDropDown[this.id] += '<span id="BlockFormats' + this.id + '" class="dropdown" style="width: 145px;">';

   	for (var i = 0; i <= BlockFormats.length;) {
   	  if (BlockFormats[i]) {
         StyleSelectDropDown[this.id] += '<button type="button" onClick="formatText(\'StyleName\',\'' + this.id + '\',\'' + BlockFormats[i] + '\')\; editorMap[\''+this.id+'\'].hideStyles();" onMouseOver="this.className=\'mouseOver\'" onMouseOut="this.className=\'mouseOut\'" class="mouseOut" style="width: 120px;"><table cellpadding="0" cellspacing="0" border="0"><tr><td align="left" style="font-size: 12px;">' + BlockFormats[i] + '</td></tr></table></button><br>';	
       }	  
   	  i++;
     }
   	StyleSelectDropDown[this.id] += '</span></td></tr></table>';
   	document.getElementById('StyleSelect' + this.id).insertAdjacentHTML("afterBegin", StyleSelectDropDown[this.id]);
   } // end outputStyleSelect


/* ---------------------------------------------------------------------- *\
  Function    : outputFontSelect()
  Description : creates the Font Select drop down and inserts it into 
	              the toolbar
  Usage       : outputFontSelect()
\* ---------------------------------------------------------------------- */
   this.outputFontSelect = function() 
   {
     var FontSelectObj        = ToolbarList['selectfont'];
     var FontSelect           = FontSelectObj[2];
     var FontSelectOn         = FontSelectObj[3];
      Fonts.sort();
   	var FontSelectDropDown = new Array;
   	FontSelectDropDown[this.id] = '<table border="0" cellpadding="0" cellspacing="0"><tr><td onMouseOver="document.getElementById(\'selectFont' + this.id + '\').src=\'' + FontSelectOn + '\';" onMouseOut="document.getElementById(\'selectFont' + this.id + '\').src=\'' + FontSelect + '\';"><img src="' + FontSelect + '" id="selectFont' + this.id + '" width="85" height="20" onClick="editorMap[\''+this.id+'\'].showFonts();" unselectable="on"><br>';
   	FontSelectDropDown[this.id] += '<span id="Fonts' + this.id + '" class="dropdown" style="width: 145px;">';
   	for (var i = 0; i <= Fonts.length;) {
        if (Fonts[i]) {
          // eb: added
          var fontRpl = FontReplacements[Fonts[i]];
         FontSelectDropDown[this.id] += '<button type="button" onClick="formatText(\'FontName\',\'' + this.id + '\',\'' + fontRpl + '\')\; editorMap[\''+this.id+'\'].hideFonts();" onMouseOver="this.className=\'mouseOver\'" onMouseOut="this.className=\'mouseOut\'" class="mouseOut" style="width: 120px;"><table cellpadding="0" cellspacing="0" border="0"><tr><td align="left" style="font-family:' + fontRpl + '; font-size: 12px;">' + Fonts[i] + '</td></tr></table></button><br>';	
       }	  
   	  i++;
     }
   	FontSelectDropDown[this.id] += '</span></td></tr></table>';
   	document.getElementById('FontSelect' + this.id).insertAdjacentHTML("afterBegin", FontSelectDropDown[this.id]);
   } // end outputFontSelect

/* ---------------------------------------------------------------------- *\
  Function    : outputFontSizes()
  Description : creates the Font Sizes drop down and inserts it into 
	              the toolbar
  Usage       : outputFontSizes()
\* ---------------------------------------------------------------------- */
   this.outputFontSizes = function() 
   {
     var FontSizeObj        = ToolbarList['selectsize'];
     var FontSize           = FontSizeObj[2];
     var FontSizeOn         = FontSizeObj[3];
   	FontSizes.sort();
   	var FontSizesDropDown = new Array;
   	FontSizesDropDown[this.id] = '<table border="0" cellpadding="0" cellspacing="0"><tr><td onMouseOver="document.getElementById(\'selectSize' + this.id + '\').src=\'' + FontSizeOn + '\';" onMouseOut="document.getElementById(\'selectSize' + this.id + '\').src=\'' + FontSize + '\';"><img src="' + FontSize + '" id="selectSize' + this.id + '" width="49" height="20" onClick="editorMap[\''+this.id+'\'].showFontSizes();" unselectable="on"><br>';
      FontSizesDropDown[this.id] += '<span id="Sizes' + this.id + '" class="dropdown" style="width: 170px;">';

   	for (var i = 0; i <= FontSizes.length;) {
   	  if (FontSizes[i]) {
         FontSizesDropDown[this.id] += '<button type="button" onClick="formatText(\'FontSize\',\'' + this.id + '\',\'' + FontSizes[i] + '\')\;editorMap[\''+this.id+'\'].hideFontSizes();" onMouseOver="this.className=\'mouseOver\'" onMouseOut="this.className=\'mouseOut\'" class="mouseOut" style="width: 145px;"><table cellpadding="0" cellspacing="0" border="0"><tr><td align="left" style="font-family: arial, verdana, helvetica;"><font size="' + FontSizes[i] + '">size ' + FontSizes[i] + '</font></td></tr></table></button><br>';	
       }	  
   	  i++;
     }
   	FontSizesDropDown[this.id] += '</span></td></tr></table>';
   	document.getElementById('FontSizes' + this.id).insertAdjacentHTML("afterBegin", FontSizesDropDown[this.id]);
   } // end outputFontSizes

/* ---------------------------------------------------------------------- *\
  Function    : hideStyles() // eb: inserted
  Description : Hides the list of font names in the font select drop down
\* ---------------------------------------------------------------------- */
    this.hideStyles = function() {
      document.getElementById('BlockFormats' + this.id).style.display = 'none'; 
   };
/* ---------------------------------------------------------------------- *\
  Function    : hideFonts()
  Description : Hides the list of font names in the font select drop down
\* ---------------------------------------------------------------------- */
   this.hideFonts = function() {
     document.getElementById('Fonts' + this.id).style.display = 'none'; 
   };
/* ---------------------------------------------------------------------- *\
  Function    : hideFontSizes()
  Description : Hides the list of font sizes in the font sizes drop down
\* ---------------------------------------------------------------------- */
   this.hideFontSizes = function() {
   document.getElementById('Sizes' + this.id).style.display = 'none'; 
   };

   /* ---------------------------------------------------------------------- *\
     Function    : showStyles() // eb: inserted
     Description : Shows the list of style names in the style select drop down
   \* ---------------------------------------------------------------------- */
   this.showStyles = function() 
   { 
     var stl = document.getElementById('BlockFormats' + this.id).style;
     if (stl.display == 'block') stl.display = 'none';
     else 
     {
        stl.display = 'block'; 
        stl.position = 'absolute';
     }
   };

/* ---------------------------------------------------------------------- *\
  Function    : showFonts()
  Description : Shows the list of font names in the font select drop down
\* ---------------------------------------------------------------------- */
   this.showFonts = function() 
   { 
     var stl = document.getElementById('Fonts' + this.id).style;
     if (stl.display == 'block') stl.display = 'none';
     else 
     {
        stl.display = 'block'; 
        stl.position = 'absolute';
     }
   };

/* ---------------------------------------------------------------------- *\
  Function    : showFontSizes()
  Description : Shows the list of font sizes in the font sizes drop down
\* ---------------------------------------------------------------------- */
   this.showFontSizes = function() 
   { 
     var stl = document.getElementById('Sizes' + this.id).style;
     if (stl.display == 'block') stl.display = 'none';
     else 
     {
        stl.display = 'block'; 
        stl.position = 'absolute';
     }
   };


/* ---------------------------------------------------------------------- *\
  Function    : create ( was generate_wysiwyg() in original)
  Description : replace textarea with wysiwyg editor
  Usage       : editor.create("textarea_id","externalCss");
  Arguments   : textarea_id - ID of textarea to replace
                externalCss - URL of external css-file to use for editor field
\* ---------------------------------------------------------------------- */
     this.create = function(textAreaID,externalCss)
     {
	     var ua = navigator.userAgent.toLowerCase();
	     if ((ua.indexOf("konqueror") != -1) || (ua.indexOf("safari") != -1))
	        return;
        this.id = textAreaID;
        editorMap[this.id] = this;
        this.textArea = document.getElementById(textAreaID);
  	     // Hide the textarea 
  	     this.textArea.style.display = 'none';
        // Generate WYSIWYG toolbar one
        var toolbar =  '<table cellpadding="0" cellspacing="0" border="0" class="toolbar1" style="width:' + this.width + ';"><tr><td style="width: 6px;"><img src="' +imagesDir+ 'seperator2.gif" alt="" hspace="3"></td>';
        // Create IDs for inserting Font Type and Size drop downs
	     // eb: StyleSelect inserted
	     toolbar += '<td style="width: 90px;"><span id="StyleSelect' + this.id + '"></span></td>';
	     toolbar += '<td style="width: 90px;"><span id="FontSelect' + this.id + '"></span></td>';
	     toolbar += '<td style="width: 60px;"><span id="FontSizes'  + this.id + '"></span></td>';
	     // Output all command buttons that belong to toolbar one
	     for (var i = 0; i <= buttonName.length;i++) { 
          if (buttonName[i]) 
          {
	         var buttonObj            = ToolbarList[buttonName[i]];
		      var buttonID             = buttonObj[0];
	         var buttonTitle          = buttonObj[1];
            var buttonImage          = buttonObj[2];
		      var buttonImageRollover  = buttonObj[3];
	    
			   if (buttonName[i] == "seperator") 
		       toolbar += '<td style="width: 12px;" align="center"><img src="' +buttonImage+ '" border=0 unselectable="on" width="2" height="18" hspace="2" unselectable="on"></td>';
	         else 
		       toolbar += '<td style="width: 22px;"><img src="' +buttonImage+ '" border=0 unselectable="on" title="' +buttonTitle+ '" id="' +buttonID+ '" class="button" onClick="formatText(this.id,\'' + this.id + '\');" onmouseover="if(className==\'button\'){className=\'buttonOver\'}; this.src=\'' + buttonImageRollover + '\';" onmouseout="if(className==\'buttonOver\'){className=\'button\'}; this.src=\'' + buttonImage + '\';" unselectable="on" width="20" height="20"></td>';
          }
        } //for i
        toolbar += '<td>&nbsp;</td></tr></table>';  
        // Generate WYSIWYG toolbar two
        var toolbar2 =  '<table cellpadding="0" cellspacing="0" border="0" class="toolbar1" style="width:' + this.width + ';"><tr><td style="width: 6px;"><img src="' +imagesDir+ 'seperator2.gif" alt="" hspace="3"></td>';
        // Output all command buttons that belong to toolbar two
        for (var j = 0; j <= buttonName2.length;j++) {
          if (buttonName2[j]) {
	          var buttonObj            = ToolbarList[buttonName2[j]];
		       var buttonID             = buttonObj[0];
	          var buttonTitle          = buttonObj[1];
             var buttonImage          = buttonObj[2];
		       var buttonImageRollover  = buttonObj[3];
	  
		      if (buttonName2[j] == "seperator") 
		        toolbar2 += '<td style="width: 12px;" align="center"><img src="' +buttonImage+ '" border=0 unselectable="on" width="2" height="18" hspace="2" unselectable="on"></td>';
	         else if (buttonName2[j] == "viewSource"){
		         toolbar2 += '<td style="width: 22px;">';
				   toolbar2 += '<span id="HTMLMode' + this.id + '"><img src="'  +buttonImage+  '" border=0 unselectable="on" title="' +buttonTitle+ '" id="' +buttonID+ '" class="button" onClick="formatText(this.id,\'' + this.id + '\');" onmouseover="if(className==\'button\'){className=\'buttonOver\'}; this.src=\'' +buttonImageRollover+ '\';" onmouseout="if(className==\'buttonOver\'){className=\'button\'}; this.src=\'' + buttonImage + '\';" unselectable="on"  width="20" height="20"></span>';
				   toolbar2 += '<span id="textMode' + this.id + '"><img src="' +imagesDir+ 'view_text.gif" border=0 unselectable="on" title="viewText"          id="ViewText"       class="button" onClick="formatText(this.id,\'' + this.id + '\');" onmouseover="if(className==\'button\'){className=\'buttonOver\'}; this.src=\'' +imagesDir+ 'view_text_on.gif\';"    onmouseout="if(className==\'buttonOver\'){className=\'button\'}; this.src=\'' +imagesDir+ 'view_text.gif\';" unselectable="on"  width="20" height="20"></span>';
	            toolbar2 += '</td>';
			  }
	        else 
		         toolbar2 += '<td style="width: 22px;"><img src="' +buttonImage+ '" border=0 unselectable="on" title="' +buttonTitle+ '" id="' +buttonID+ '" class="button" onClick="formatText(this.id,\'' + this.id + '\');" onmouseover="if(className==\'button\'){className=\'buttonOver\'}; this.src=\'' +buttonImageRollover+ '\';" onmouseout="if(className==\'buttonOver\'){className=\'button\'}; this.src=\'' + buttonImage + '\';" unselectable="on" width="20" height="20"></td>';
         }
       } // for j
       toolbar2 += '<td>&nbsp;</td></tr></table>';  
	    // Create iframe which will be used for rich text editing
	    var iframe = '<table cellpadding="0" cellspacing="0" border="0" style="width:' + this.width + '; height:' + this.height + ';border: 1px inset #CCCCCC;"><tr><td valign="top">\n'
       + '<iframe frameborder="0" id="wysiwyg' + this.id + '"></iframe>\n'
       + '</td></tr></table>\n';

  // Insert after the textArea both toolbar one and two
       this.textArea.insertAdjacentHTML("afterEnd", toolbar + toolbar2 + iframe);

   	this.outputStyleSelect(); this.outputFontSelect(); this.outputFontSizes(); 
	
  // Hide the dynamic drop down lists for the Font Types and Sizes
      this.hideStyles(); this.hideFonts(); this.hideFontSizes();

   	// Hide the "Text Mode" button
   	document.getElementById("textMode" + this.id).style.display = 'none'; 
   	// Give the iframe the global wysiwyg height and width
      document.getElementById("wysiwyg" + this.id).style.height = this.height;
      document.getElementById("wysiwyg" + this.id).style.width = this.width;

      var content = "<html><head>"
      if ((externalCss != null) && (externalCss != ""))
      {
          content += "<link media=\"all\" type=\"text/css\" href=\"" + externalCss + "\" rel=\"stylesheet\">\n";
      }
      content += "</head><body style=\"background-image: none\">";
      var txt = this.textArea.value;
      if (txt == "") txt = "&nbsp;"; // eb: Hack for Mozilla
      content += txt;
	   content += "</body></html>";
	   this.editFrame = document.getElementById("wysiwyg" + this.id);
	   var doc = this.editFrame.contentWindow.document;
	
	   // Write the textarea's content into the iframe
      doc.designMode = "on";
      doc.open();
      doc.write(content);
      doc.close();
	
	   // Make the iframe editable in both Mozilla and IE
	   if (doc.all)
        doc.body.contentEditable = true;
      doc.designMode = "on";
	
    	// Update the textarea with content in WYSIWYG when user submits form
      var browserName = navigator.appName;
      var form = getParentByNodeName('form',this.textArea);
      var idstr=this.id;
      if (form != null)
      {
      if (browserName == "Microsoft Internet Explorer") {
         form.attachEvent('onsubmit', function() { return editorMap[idstr].updateTextArea(); });
         form.attachEvent('onreset', function() { editorMap[idstr].reset(); });
      }
      else {
  	      form.setAttribute('onSubmit','return editorMap[\''+textAreaID+'\'].updateTextArea()');
         form.addEventListener('reset',function OnReset() { editorMap[idstr].reset(); }, true);
         }
      }
    } // end create function

/* ---------------------------------------------------------------------- *\
  Function    : viewSource()
  Description : Shows the HTML source code generated by the WYSIWYG editor
\* ---------------------------------------------------------------------- */
   this.viewSource = function() 
   {
      var getDocument = this.editFrame.contentWindow.document;
      var browserName = navigator.appName;
	
	  // View Source for IE 	 
      if (browserName == "Microsoft Internet Explorer") {
         var iHTML = getDocument.body.innerHTML;
         getDocument.body.innerText = iHTML;
	   }
 
      // View Source for Mozilla/Netscape
      else {
         var html = document.createTextNode(getDocument.body.innerHTML);
         getDocument.body.innerHTML = "";
         getDocument.body.appendChild(html);
	   }
  
	  // Hide the HTML Mode button and show the Text Mode button
      document.getElementById('HTMLMode' + this.id).style.display = 'none'; 
	   document.getElementById('textMode' + this.id).style.display = 'block';
	
	   // set the font values for displaying HTML source
	  getDocument.body.style.fontSize = "12px";
	  getDocument.body.style.fontFamily = "Courier New"; 
	
      this.viewTextMode = 1;
   };

/* ---------------------------------------------------------------------- *\
  Function    : viewText()
  Description : Shows editable richtext
\* ---------------------------------------------------------------------- */
   this.viewText = function() 
   { 
      var getDocument = this.editFrame.contentWindow.document;
      var browserName = navigator.appName;
	
	  // View Text for IE 	  	 
      if (browserName == "Microsoft Internet Explorer") {
         var iText = getDocument.body.innerText;
         getDocument.body.innerHTML = iText;
	   }
  
	  // View Text for Mozilla/Netscape
      else {
         var html = getDocument.body.ownerDocument.createRange();
         html.selectNodeContents(getDocument.body);
         getDocument.body.innerHTML = html.toString();
	  }
  
	  // Hide the Text Mode button and show the HTML Mode button
      document.getElementById('textMode' + this.id).style.display = 'none'; 
	   document.getElementById('HTMLMode' + this.id).style.display = 'block';
	
	  // reset the font values
      getDocument.body.style.fontSize = "";
	   getDocument.body.style.fontFamily = ""; 
	   this.viewTextMode = 0;
   };

} // end class KsWyEdit

// ============================================================================


// eb: modified - handles blockformats too
/* ---------------------------------------------------------------------- *\
  Function    : formatText()
  Description : replace textarea with wysiwyg editor
  Usage       : formatText(id, n, selected);
  Arguments   : id - The execCommand (e.g. Bold)
                n  - The editor identifier that the command 
								     affects (the textarea's ID)
                selected - The selected value when applicable (e.g. Arial)
\* ---------------------------------------------------------------------- */
function formatText(id, n, selected) 
{
  var editor = editorMap[n];
  if (editor == null) return;
  var frameWindow = editor.editFrame.contentWindow;
  // When user clicks toolbar button make sure it always targets its respective WYSIWYG
  frameWindow.focus();
	
	// When in Text Mode these execCommands are disabled
	var formatIDs = new Array("hruler","StyleName","FontSize","FontName","Bold","Italic","Underline","Subscript","Superscript","Strikethrough","Justifyleft","Justifyright","Justifyfull","Justifycenter","InsertUnorderedList","InsertOrderedList","Indent","Outdent","ForeColor","BackColor","InsertImage","InsertTable","CreateLink");
  
	// Check if button clicked is in disabled list
	for (var i = 0; i <= formatIDs.length;) {
		if (formatIDs[i] == id) {
			 var disabled_id = 1; 
		}
	  i++;
	}
	
	// Check if in Text Mode and disabled button was clicked
	if (editor.viewTextMode == 1 && disabled_id == 1) {
	  alert ("You are in HTML Mode. This feature has been disabled.");	
	}
	
	else {
	
	  // FontSize
	  if (id == "FontSize") {
      frameWindow.document.execCommand("FontSize", false, selected);
	  }
	  
		// FontName
	  else if (id == "FontName") {
      frameWindow.document.execCommand("FontName", false, selected);
	  }
	
	  // ForeColor and BackColor
    else if (id == 'ForeColor' || id == 'BackColor') {
      var w = screen.availWidth;
      var h = screen.availHeight;
      var popW = 210, popH = 165;
      var leftPos = (w-popW)/2, topPos = (h-popH)/2;
      var currentColor = _dec_to_rgb(frameWindow.document.queryCommandValue(id));
   
	    window.open(popupsDir + 'select_color.html?color=' + currentColor + '&command=' + id + '&wysiwyg=' + n,'popup','location=0,status=0,scrollbars=0,width=' + popW + ',height=' + popH + ',top=' + topPos + ',left=' + leftPos);
    }
	  
		// InsertImage
	  else if (id == "InsertImage") {
      window.open(popupsDir +popupExt+ 'insert_image.html?wysiwyg=' + n,'popup','location=0,status=0,scrollbars=0,resizable=0,width=400,height=190');
	  }
	  
		// InsertTable
	  else if (id == "InsertTable") {
	    window.open(popupsDir +popupExt+ 'create_table.html?wysiwyg=' + n,'popup','location=0,status=0,scrollbars=0,resizable=0,width=400,height=360');
	  }
		// eb: inserted - insertlayer
	  else if (id == "insertlayer") {
	    window.open(popupsDir +popupExt + 'create_div.html?wysiwyg=' + n,'popup','location=0,status=0,scrollbars=0,resizable=0,width=560,height=400');
	  }
	  
		// CreateLink
	  else if (id == "CreateLink") { // eb: window height modified 110 -> 140
	    window.open(popupsDir +popupExt + 'insert_hyperlink.html?wysiwyg=' + n,'popup','location=0,status=0,scrollbars=0,resizable=0,width=300,height=150');
	  }
	  
		// ViewSource
    else if (id == "ViewSource") {
	    editor.viewSource();
	  }
		
		// ViewText
		else if (id == "ViewText") {
	    editor.viewText();
	  }

		// Help
		else if (id == "Help") {
	    window.open(popupsDir + 'about.html','popup','location=0,status=0,scrollbars=0,resizable=0,width=400,height=330');
	  }
	  //  eb: inserted
	  else if (id == "StyleName")
	  {
        var tag= BlockTags[selected];
        var sel = getCurrentSelection(n);
        try
        {
          if (!frameWindow.document.execCommand("FormatBlock", false, tag))
          {
            if (!frameWindow.document.execCommand("FormatBlock", false, "<" + tag + ">"))
            {
   		    // get current selection
              var html = "<"+tag+">" + sel + "</" + tag+">";
      	      insertHTML(html,n);
		    }
          }
        }
        catch (e)
        { 
		  // get current selection
            var html = "<"+tag+">" + sel + "</" + tag+">";
    	    insertHTML(html,n);
        }
     }
     else if (id == "hruler")
     {
       insertHTML("<hr>",n);
      }
	  
		// Every other command
	  else {
      frameWindow.document.execCommand(id, false, null);
		}
  }
};

/* ---------------------------------------------------------------------- *\
  Function    : insertHTML()
  Description : insert HTML into WYSIWYG in rich text
  Usage       : insertHTML(<b>hello</b>, "textareaID")
  Arguments   : html - The HTML being inserted (e.g. <b>hello</b>)
                n  - The editor identifier that the HTML 
								     will be inserted into (the textarea's ID)
\* ---------------------------------------------------------------------- */
// eb: modified
/*
    Inserted HTML is enclosed by DIV-Tag on IE too. In both cases that tag is a temporary one and removed after
    insertion. Function returns inserted node. Note that this implementation allows only one node to be inserted.
*/
function insertHTML(html, n) {

  var browserName = navigator.appName;
  var destDoc = document.getElementById('wysiwyg' + n).contentWindow.document;	 	 
  var tmpId = 'wysiwygtmpdiv' + n;	 	 
	if (browserName == "Microsoft Internet Explorer") {	  
	  destDoc.selection.createRange().pasteHTML('<div id="' + tmpId + '">' + html  + '</div>');   
	} 
	 
	else {
	  var div = destDoc.createElement("div");
		div.setAttribute('id',tmpId); 
		div.innerHTML = html;
		var node = insertNodeAtSelection(div, n);		
	}
  var tmpDiv = destDoc.getElementById(tmpId);	
  var parentNode = tmpDiv.parentNode;
  var innerNode = tmpDiv.firstChild;
  if (innerNode == null)
  {
     parentNode.removeChild(tmpDiv);
     return null;
  }
  innerNode = innerNode.cloneNode(true);
  parentNode.replaceChild(innerNode,tmpDiv);
  return innerNode;
}

function getCurrentSelection(n)
{
  var win = document.getElementById('wysiwyg' + n).contentWindow;
  var doc = win.document;
  if (doc.getSelection) {
    return doc.getSelection();
  } else if (win.getSelection) {
    return window.getSelection().toString();
  } else if (doc.selection) {
    return doc.selection.createRange().text;
  }
  return "";
}

/* ---------------------------------------------------------------------- *\
  Function    : insertNodeAtSelection()
  Description : insert HTML into WYSIWYG in rich text (mozilla)
  Usage       : insertNodeAtSelection(insertNode, n)
  Arguments   : insertNode - The HTML being inserted (must be innerHTML 
	                           inserted within a div element)
                n          - The editor identifier that the HTML will be 
								             inserted into (the textarea's ID)
\* ---------------------------------------------------------------------- */
function insertNodeAtSelection(insertNode, n) {
  // get current selection
  var sel = document.getElementById('wysiwyg' + n).contentWindow.getSelection();

  // get the first range of the selection
  // (there's almost always only one range)
  var range = sel.getRangeAt(0);

  // deselect everything
  sel.removeAllRanges();

  // remove content of current selection from document
  range.deleteContents();

  // get location of current selection
  var container = range.startContainer;
  var pos = range.startOffset;

  // make a new range for the new selection
  range=document.createRange();

  if (container.nodeType==3 && insertNode.nodeType==3) {

    // if we insert text in a textnode, do optimized insertion
    container.insertData(pos, insertNode.nodeValue);

    // put cursor after inserted text
    range.setEnd(container, pos+insertNode.length);
    range.setStart(container, pos+insertNode.length);
  } 
	
	else {
    var afterNode;
    
		if (container.nodeType==3) {
      // when inserting into a textnode
      // we create 2 new textnodes
      // and put the insertNode in between

      var textNode = container;
      container = textNode.parentNode;
      var text = textNode.nodeValue;

      // text before the split
      var textBefore = text.substr(0,pos);
      // text after the split
      var textAfter = text.substr(pos);

      var beforeNode = document.createTextNode(textBefore);
      afterNode = document.createTextNode(textAfter);

      // insert the 3 new nodes before the old one
      container.insertBefore(afterNode, textNode);
      container.insertBefore(insertNode, afterNode);
      container.insertBefore(beforeNode, insertNode);

      // remove the old node
      container.removeChild(textNode);
    } 
	
	  else {
      // else simply insert the node
      afterNode = container.childNodes[pos];
      container.insertBefore(insertNode, afterNode);
    }

   try
   {
     // fails on Opera Browser
    range.setEnd(afterNode, 0);
    range.setStart(afterNode, 0);
  }
   catch (e) { }
  }

  sel.addRange(range);
};


/* ---------------------------------------------------------------------- *\
  Function    : _dec_to_rgb
  Description : convert a decimal color value to rgb hexadecimal
  Usage       : var hex = _dec_to_rgb('65535');   // returns FFFF00
  Arguments   : value   - dec value
\* ---------------------------------------------------------------------- */

function _dec_to_rgb(value) {
  var hex_string = "";
  for (var hexpair = 0; hexpair < 3; hexpair++) {
    var myByte = value & 0xFF;            // get low byte
    value >>= 8;                          // drop low byte
    var nybble2 = myByte & 0x0F;          // get low nybble (4 bits)
    var nybble1 = (myByte >> 4) & 0x0F;   // get high nybble
    hex_string += nybble1.toString(16);   // convert nybble to hex
    hex_string += nybble2.toString(16);   // convert nybble to hex
  }
  return hex_string.toUpperCase();
};


